#!/usr/bin/env ruby

require 'qte'
require 'qpe'


require "timeout"
require "open-uri"

#require "nkf"

require "rexml/document"

include Qte
include Qpe


class MyWidget < QWidget
	def initialize(parnet = nil, name = '')
		super(parnet, name)
		setCaption(tr("YahoonewsTTR"))
		bg = QVButtonGroup.new(self)
		bg.setGeometry(0,20,638,150)

		@yhpath = "/home/samba/SD_Card/Documents/Image_Files/"
		@yhpathset = "/home/zaurus/Settings/"

		if (!FileTest.exist?(@yhpathset + "yhttr.xml"))
			$yhpaths = "/home/samba/SD_Card/Documents/Image_Files/"
			$yhpathm = "/home/zaurus/Documents/Image_Files/"
			$yhpathc = "/home/samba/CF_Card/Documents/Image_Files/"
		end


		@Menu = QPopupMenu.new()
		@ms = @Menu.insertItem(tr("取得開始"), self, "getyahoo", CTRL+Key_G)
		@me = @Menu.insertItem(tr("取得中止"), self, "stopgetyahoo", CTRL+Key_S)
		@Menu.setItemEnabled(@me,false)
		@Menu.insertItem(tr("TTexttReaderで開く"), self, "runttr", CTRL+Key_J)
		@Menu.insertItem(tr("TTexttReaderで開く(高速)"), self, "runttrk", CTRL+Key_K)
		@setting1 = QPopupMenu.new()
		@setting1.insertItem(tr("スポーツ"), self, "cateset1", CTRL+Key_Q)
		@setting1.insertItem(tr("経済総合"), self, "cateset2", CTRL+Key_W)
		@setting1.insertItem(tr("株式"), self, "cateset3", CTRL+Key_E)
		@setting1.insertItem(tr("社会"), self, "cateset4", CTRL+Key_R)
		@setting1.insertItem(tr("政治"), self, "cateset5", CTRL+Key_T)
		@setting1.insertItem(tr("海外"), self, "cateset6", CTRL+Key_Y)
		@setting1.insertItem(tr("市況"), self, "cateset7", CTRL+Key_U)
		@setting1.insertItem(tr("産業"), self, "cateset8", CTRL+Key_I)
		@setting1.insertItem(tr("エンターテーメント"), self, "cateset9", CTRL+Key_O)
		@setting1.insertItem(tr("コンピュータ"), self, "cateset10", CTRL+Key_P)
		@setting1.insertItem(tr("個別記事"), self, "cateset11", CTRL+Key_L)
		@setting2 = QPopupMenu.new()
		@setting2.insertItem(tr("新規"), self, "onradio1", CTRL+Key_N)
		@setting2.insertItem(tr("上書き"), self, "onradio2", CTRL+Key_M)
		@md = @setting2.insertItem(tr("保存先設定"), self, "savedirectory", CTRL+Key_D)
		@menuBar = QPEMenuBar.new(self)
		@menuBar.insertItem(tr("Menu"), @Menu)
		@menuBar.insertItem(tr("カテゴリー"), @setting1)
		@menuBar.insertItem(tr("保存設定"), @setting2)


		bg.setTitle(tr("Yahoo!ニュース　取得カテゴリ設定"))
		bg.setGeometry(0,30,639,465)
		QLabel.new(tr("取得記事数(1-25)\n"),bg)
		@l1 = QLineEdit.new("25",self)
		@l1.setGeometry(180,53,30,30)

		@r1 = QRadioButton.new(tr("新規"),self)
		@r2 = QRadioButton.new(tr("上書き"),self)
		@r1.setChecked(true)

		@r1.setGeometry(220,53,110,30)
		@r2.setGeometry(295,53,90,30)

		@m1 = QComboBox.new(self)
		@m1.setGeometry(400,53,70,30)

		@m1.insertItem("SD")
		@m1.insertItem(tr("本体"))
		@m1.insertItem("CF")

		@c1 = QCheckBox.new(tr("Q.スポーツ"),self)
		@c2 = QCheckBox.new(tr("W.経済総合"),self)
		@c3 = QCheckBox.new(tr("E.株式"),self)
		@c4 = QCheckBox.new(tr("R.社会"),self)
		@c5 = QCheckBox.new(tr("T.政治"),self)

		@c6 = QCheckBox.new(tr("Y.海外"),self)
		@c7 = QCheckBox.new(tr("U.市況"),self)
		@c8 = QCheckBox.new(tr("I.産業"),self)
		@c9 = QCheckBox.new(tr("O.エンタメ"),self)
		@c10 = QCheckBox.new(tr("P.コンピュータ"),self)

		@c11 = QCheckBox.new(tr("L.個別設定"),self)

		@c1.setGeometry(10,93,130,30)
		@c2.setGeometry(10,133,130,30)
		@c3.setGeometry(10,173,130,30)
		@c4.setGeometry(10,213,130,30)
		@c5.setGeometry(10,253,130,30)

		@c6.setGeometry(150,93,130,30)
		@c7.setGeometry(150,133,130,30)
		@c8.setGeometry(150,173,130,30)
		@c9.setGeometry(150,213,230,30)
		@c10.setGeometry(150,253,180,30)

		@c11.setGeometry(330,93,150,30)
		@e2 = QMultiLineEdit.new(self)
		@e2.setGeometry(330,130,295,150)

		@m = QPushButton.new(tr("取得開始( Ctrl + G )"),self)
		@m.setGeometry(10,295,300,40)

		@m3 = QPushButton.new(tr("取得中止( Ctrl + S )"),self)
		@m3.setEnabled(false)
		@m3.setGeometry(330,295,300,40)

		@m2 = QPushButton.new(tr("TTexttReader開"),self)
		@m2.setGeometry(475,53,150,30)
		
		@l2 = QLabel.new(tr("status"),self)
		@l2.setGeometry(10,340,300,20)
		@e1 = QLineEdit.new("",self)
		@e1.setGeometry(10,365,620,30)
		@e1.setReadOnly(true)

		load(@yhpathset + "yhttr.xml")
		connect(@m,QSIGNAL("clicked()"), self, 'getyahoo')
		connect(@m3,QSIGNAL("clicked()"), self, 'stopgetyahoo')
		connect(@m2,QSIGNAL("clicked()"), self, 'runttr')
		connect(@r1,QSIGNAL("clicked()"), self, 'offradio1')
		connect(@r2,QSIGNAL("clicked()"), self, 'offradio2')

	end

	def pathset
		case @m1.currentItem.to_i
		when 0
			@yhpath = $yhpaths
		when 1
			@yhpath = $yhpathm
		when 2
			@yhpath = $yhpathc	
		end
	end

	def pathset2
		case @m1.currentItem.to_i
		when 0
			@yhpath2 = $yhpaths
		when 1
			@yhpath2 = $yhpathm
		when 2
			@yhpath2 = $yhpathc	
		end
	end

	def runttr
		pathset2

		begin
			system("qcop QPE/Application/TTextReader 'openEuc(QString)' " + @yhpath2 + "yahoo_news.txt")
		rescue
			@e1.setText(tr("TTexttReader open error"))					
		end
	end

	def runttrk
		pathset2

		begin
			system("qcop QPE/System 'execute(QString,QString)' TTextReader " + @yhpath2 + "yahoo_news.txt")
		rescue
			@e1.setText(tr("TTexttReader open error"))					
		end
	end


	def offradio1
		@r2.setChecked(false)	
	end

	def offradio2
		@r1.setChecked(false)	
	end

	def onradio1
		@r1.setChecked(true)
		@r2.setChecked(false)	
	end

	def onradio2
		@r1.setChecked(false)
		@r2.setChecked(true)
	end

	def cateset1
		if @c1.isChecked then
			@c1.setChecked(false)
		else
			@c1.setChecked(true)
		end
	end

	def cateset2
		if @c2.isChecked then
			@c2.setChecked(false)
		else
			@c2.setChecked(true)
		end
	end

	def cateset3
		if @c3.isChecked then
			@c3.setChecked(false)
		else
			@c3.setChecked(true)
		end
	end

	def cateset4
		if @c4.isChecked then
			@c4.setChecked(false)
		else
			@c4.setChecked(true)
		end
	end

	def cateset5
		if @c5.isChecked then
			@c5.setChecked(false)
		else
			@c5.setChecked(true)
		end
	end

	def cateset6
		if @c6.isChecked then
			@c6.setChecked(false)
		else
			@c6.setChecked(true)
		end
	end

	def cateset7
		if @c7.isChecked then
			@c7.setChecked(false)
		else
			@c7.setChecked(true)
		end
	end

	def cateset8
		if @c8.isChecked then
			@c8.setChecked(false)
		else
			@c8.setChecked(true)
		end
	end

	def cateset9
		if @c9.isChecked then
			@c9.setChecked(false)
		else
			@c9.setChecked(true)
		end
	end

	def cateset10
		if @c10.isChecked then
			@c10.setChecked(false)
		else
			@c10.setChecked(true)
		end
	end

	def cateset11
		if @c11.isChecked then
			@c11.setChecked(false)
		else
			@c11.setChecked(true)
		end
	end

	def stopgetyahoo
		if @t != nil then
			@t.kill()
			@e1.setText(tr("取得中止 -> output yahoo_news.txt"))
			@Menu.setItemEnabled(@ms,true)
			@Menu.setItemEnabled(@me,false)
			@setting2.setItemEnabled(@md,true)
			@m.setEnabled(true)
			@m3.setEnabled(false)

			if (FileTest.exist?(@categ + ".dat"))
				File.delete(@categ + ".dat")	
			end
			if (FileTest.exist?(@categ + ".txt"))
				File.delete(@categ + ".txt")	
			end

			GC.start
		end
	end

	def savedirectory
		dlg = SaveDirectoryDialog.new(self)
		res = dlg.exec()
	end

	def getyahoo
	  begin
	   @t = Thread.start do
		Thread.pass

		@Menu.setItemEnabled(@ms,false)
		@Menu.setItemEnabled(@me,true)
		@setting2.setItemEnabled(@md,false)
		@m.setEnabled(false)
		@m3.setEnabled(true)

		pathset

		if (!FileTest.exist?(@yhpath))
			Dir.mkdir(@yhpath)
		end
		
		begin
		if @r1.isChecked then
			fp = File.open(@yhpath + "yahoo_news.txt","w")
				day = Time.now
				yhdate = ".Yahoo!news " + day.year.to_s + "-" + day.month.to_s + "-" + day.day.to_s + " " + day.hour.to_s + ":" + day.min.to_s
				fp.puts(yhdate)
			fp.close
		else
			fp = File.open(@yhpath + "yahoo_news.txt","a")
				day = Time.now
				yhdate = ".Yahoo!news " + day.year.to_s + "-" + day.month.to_s + "-" + day.day.to_s + " " + day.hour.to_s + ":" + day.min.to_s
				fp.puts(yhdate)
			fp.close
		end
		rescue
			@e1.setText(tr("保存先エラー"))
			return					
		end
		
		tempurl = ""
		tempcate = ""
		tempcate2= ""
		@newsmaxc = @l1.text.to_str
		@newsmax = @newsmaxc.to_i

		save(@yhpathset + "yhttr.xml")

		if @c1.isChecked then
			@e1.setText(tr("スポーツ記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=spo&t=l','spo','off')
			yahoodat('spo')
		end
		if @c2.isChecked then
			@e1.setText(tr("経済総合記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=bus_all&t=l','bus_all','off')
			yahoodat('bus_all')
		end
		if @c3.isChecked then
			@e1.setText(tr("株式記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=biz&t=l','biz','off')
			yahoodat('biz')
		end
		if @c4.isChecked then
			@e1.setText(tr("社会記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=soci&t=l','soci','off')
			yahoodat('soci')
		end
		if @c5.isChecked then
			@e1.setText(tr("政治記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=pol&t=l','pol','off')
			yahoodat('pol')
		end
		if @c6.isChecked then
			@e1.setText(tr("海外記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=int&t=l','int','off')
			yahoodat('int')
		end
		if @c7.isChecked then
			@e1.setText(tr("市況記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=brf&t=l','brf','off')
			yahoodat('brf')
		end
		if @c8.isChecked then
			@e1.setText(tr("産業記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=ind&t=l','ind','off')
			yahoodat('ind')
		end
		if @c9.isChecked then
			@e1.setText(tr("エンターテーメント記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=ent&t=l','ent','off')
			yahoodat('ent')
		end
		if @c10.isChecked then
			@e1.setText(tr("コンピュータ記事一覧取得開始"))
			getyahoourl('http://headlines.yahoo.co.jp/hl?c=sci&t=l','sci','off')
			yahoodat('sci')
		end
		if @c11.isChecked then
			@e2.text.to_str.each do |line|
				if ( line =~ /^\#/ ) != nil then
				else
					if ( line =~ /^\/fc/ ) != nil then
						tempurl = "http://dailynews.yahoo.co.jp" + line
						tempcate = line
						tempcate2 = tempcate.split('/')
						@kobetu = tempcate2[3]
						@e1.setText(QString::fromUtf8("個別設定記事(" + @kobetu + ")一覧取得開始"))
						getyahoourl(tempurl,@kobetu,'on')
						yahoodat(@kobetu)
					end
					if ( line =~ /^\/weather/ ) != nil then
						lineurl = line.split(',')
						@tempurl = "http://weather.yahoo.co.jp" + lineurl[0]
						getweather(@tempurl)
						tempcate = lineurl[0]
						tempcate2 = tempcate.split('/')
						if lineurl[1] != nil then
							if lineurl[1].to_i <= 6 then
								@tempurl = "http://weather.yahoo.co.jp/weather/raincloud/" + tempcate2[3] + "/index.html" + "?c=" + lineurl[1]
							else
								@tempurl = "http://weather.yahoo.co.jp/weather/raincloud/" + tempcate2[3] + "/index.html" + "?c=6"
							end
						else
							@tempurl = "http://weather.yahoo.co.jp/weather/raincloud/" + tempcate2[3] + "/index.html"
						end
						getweather2(@tempurl)
					end
				end
			end
		end

		if @okflag then
			@e1.setText(tr("取得完了 -> output yahoo_news.txt complete!"))
		else
			@e1.setText(tr("network error! 取得失敗したカテゴリーがあります。 -> output yahoo_news.txt"))	
		end
		@Menu.setItemEnabled(@ms,true)
		@Menu.setItemEnabled(@me,false)
		@setting2.setItemEnabled(@md,true)
		@m.setEnabled(true)
		@m3.setEnabled(false)
		GC.start
	    end
	  rescue
	    return
	  end
	end

	def getyahoourl(yahoourl, cate, yhoption)
		@categ = cate
		begin
		fp1 = File.open(cate + ".txt","w")
			open(yahoourl) do |f|
				f.each_line() do |line|
					fp1.puts(line)
				end
			end
			@okflag = true
		fp1.close
		rescue
			@okflag = false
			return
		end
		show()

		templine = []
		yhurl = ""
		buf = ""
		ulMode = false
		titleMode = false
		status = ""

		fp1 = File.open(cate + ".txt","r")
		fp1.each do |line|
			if (line =~ /<title>/) != nil then
				if (line =~ /<\/head>/) then
					catemp = line.sub(/<title>Yahoo.*-  /,"")
					@catename = catemp.sub(/<\/title><\/head>/,"")
				end
				titleMode = true
			end
			if (line =~ /<\/title>/) != nil then
				titleMode = false
			end
			if titleMode then
				if (line =~ /<title>/) then
				else
					@catename = line
				end
			end
			if ( yhoption =~ /off/ ) != nil then
				if (line =~ /<ul>/) != nil then
					ulMode = true
				end
				if ulMode then
					temp = line .split('"')
					templine.push temp[1]
					templine.push temp[2]
					templine.push temp[3]
					templine.push temp[4]
					templine.push temp[5]
					templine.push temp[6]
					templine.push temp[7]
					templine.push temp[8]
					templine.push temp[9]
					templine.push temp[10]
					templine.push temp[11]
					templine.push temp[12]
					templine.push temp[13]
					templine.push temp[14]
					templine.push temp[15]
					templine.push temp[16]
					templine.push temp[17]
				end
				if (line =~ /<\/ul>/) != nil then
					ulMode = false
				end
			else
				if (line =~ /OUTLINE/) != nil then
					ulMode = true
				end
				if (line =~ /news_stories/) != nil then
					ulMode = false
				end
				if ulMode then
					temp = line .split('"')
					templine.push temp[3]
				end

			end
		end
		fp1.close
		fp1 = ""

		count = 0
		fp2 = File.open(cate + ".dat","w")
		fp2.puts("  ")
		templine.each do |line|
			if (line != nil ) && ( count < @newsmax )  then
				if (line =~ /http|yahoo/) != nil then
					if (line =~ /photo/) != nil then
					else
						count += 1

						if (cate =~ /spo/) then
							@e1.setText(tr("スポーツ記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /bus_all/) then
							@e1.setText(tr("経済総合記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /biz/) then
							@e1.setText(tr("株式記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /soci/) then
							@e1.setText(tr("社会記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /pol/) then
							@e1.setText(tr("政治記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /int/) then
							@e1.setText(tr("海外記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /brf/) then
							@e1.setText(tr("市況記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /ind/) then
							@e1.setText(tr("産業記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /ent/) then
							@e1.setText(tr("エンターテーメント記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						elsif (cate =~ /sci/) then
							@e1.setText(tr("コンピュータ記事取得中 " + count.to_s + "\/" + @newsmax.to_s))
						else
							@e1.setText(tr("個別設定記事(" + @kobetu + ")取得中 " + count.to_s + "\/" + @newsmax.to_s))
						end
						begin
							open(line) do |f|
								f.each_line() do |linehtml|
									fp2.puts(linehtml)
								end
							end
						rescue
							#@okflag = false
							#return
						end
					end
				end
			end
		end
		templine = ""
		fp2.close
	end

	def yahoodat(cate)
		templine = []
		tempnews = []
		imgline = []
		fp = []
		yhurl = ""
		buf = ""
		titleMode = false
		newsMode = false
		news2Mode = false
		photoMode = false
		sedline = ""
		sedline2 = ""

			begin
				fp = File.open(cate + ".dat","r")
			rescue

				if (FileTest.exist?(@categ + ".txt"))
					File.delete(@categ + ".txt")	
				end
				return
			end
			templine.push "..Yahoo!news " + @catename
			fp.each_line() do |line|
				if (line =~ /<title>/) != nil then
					titleMode = true
				end
				if (line =~ /<\/title>/) != nil then
					titleMode = false
				end
				if titleMode then
					if (line =~ /<title>/) then
					else
						templine.push "..." + line
					end
				end
				if (line =~ /\/CONTENTS_TITLE_TABLE/) != nil then
					newsMode = true
				end
				if (line =~ /^<center>/) != nil then
					newsMode = false
					news2Mode = false
				end
				if newsMode then
					if (line =~ /<b>/) != nil then
						if (line =~ /<\/font>/) != nil then						
							news2Mode = true
						end
					end
				end
				if news2Mode then
					if (line =~ /\/NEXT_NAVI_TABLE/) != nil then
						photoMode = true
					end
				end
				if (line =~ /^<table cellpadding=3 cellspacing=0 border=0 width=500>/) != nil then
					photoMode = true
				end
				if (line =~ /^<p><center>|^<\/td><\/tr>/) != nil then
					photoMode = false
				end				
				if ( news2Mode | photoMode ) then
						#templine.push line
						if (line =~ /images/) != nil then
							temp = line .split('"')
							if (temp[9] =~ /jpg/) != nil then
								if temp[9] == nil then
								else
									@e1.setText(tr("画像取得開始")) 
									begin
										system("wget -P " + @yhpath + " -nv -nc -T 4 -t 1 " + temp[9] + "")
									rescue
									end
									#-nv -nc
									@e1.setText(tr("画像取得完了")) 
								end
							end
							if (temp[11] =~ /jpg/) != nil then
								if temp[11] == nil then
								else
									@e1.setText(tr("画像取得開始")) 
									begin
										system("wget -P " + @yhpath + " -nv -nc -T 4 -t 1 " + temp[11] + "")
									rescue
									end
									@e1.setText(tr("画像取得完了")) 
								end
							end
							if (temp[5] =~ /jpg/) != nil then
								if temp[5] == nil then
								else
									@e1.setText(tr("画像取得開始"))
									begin 
										system("wget -P " + @yhpath + " -nv -nc -T 4 -t 1 " + temp[5] + "")
									rescue
									end
									@e1.setText(tr("画像取得完了")) 
								end
							end
							sedline  = line.sub(/http:\/\/ca.c.yimg.*images\/........\/[a-z]*\//,@yhpath)
							sedline2 = sedline.sub(/http:\/\/ca.c.yimg.*images\/........\/[a-z]*_[a-z]*\//,@yhpath)
							templine.push sedline2.sub(/\.jpg /,"\.jpg")
						else
							templine.push line
						end
				end
			end
			fp.close
			
			fp = File.open( @yhpath + "yahoo_news.txt","a")
			templine.each do |line|
				fp.puts(line)
			end
			fp.close

			File.delete(cate + ".dat")
			File.delete(cate + ".txt")

		templine = ""
		tempnews = ""
		imgline = ""
		buf = ""
		fp = ""
		GC.start
	end

	def getweather(weatherurl)
		@categ = "weather"

		pathset

		templine = []
		line = ""
		linesed = ""
		titleMode = false
		weatherMode = false
		weather2Mode = false
		@e1.setText(QString::fromUtf8("天気情報取得開始"))
		begin
		fp1 = File.open("weather.txt","w")
			open(weatherurl) do |f|
				f.each_line() do |line|
					fp1.puts(line)
				end
			end
			@okflag = true
		fp1.close
		rescue
			@okflag = false
			return
		end

		fp1 = File.open("weather.txt","r")
		fp1.each do |line|
				if (line =~ /<title>/) != nil then
					titleMode = true
				end
				if titleMode then
					linesed = line.sub(/<title>/,"")
					templine.push ".." + linesed.sub(/<\/title>/,"")
				end
				if (line =~ /<\/title>/) != nil then
					titleMode = false
				end
				if (line =~ /\/LEFT_COLUMN/) != nil then
					weatherMode = true
				end
				if weatherMode then
					if (line =~ /490/) != nil then
						weather2Mode = true
					end
				end
				if weather2Mode then
					if (line =~ /clear.gif/) != nil then
					else
						#templine.push line
						if (line =~ /images/) != nil then
							temp = line .split('"')
							if (temp[1] =~ /gif/) != nil then
								if temp[1] == nil then
								else
									@e1.setText(QString::fromUtf8("天気アイコン取得開始"))
									begin
										system("wget -P " + @yhpath + " -nv -nc -T 4 -t 1 " + temp[1] + "")
									rescue
									end
									@e1.setText(QString::fromUtf8("天気アイコン画像取得開始"))
								end
							end
							sedline  = line.sub(/http:\/\/ca.c.yimg.*forcast\//,@yhpath)
							sedline2  = sedline.sub(/pinpoint\//,"")
							templine.push sedline2.sub(/\.gif /,"\.gif")
						else
							templine.push line
						end
					end
				end
				if (line =~ /Local_Link/) != nil then
					weatherMode = false
					weather2Mode = false
				end
		end
		fp1.close

		fp = File.open( @yhpath + "yahoo_news.txt","a")
		templine.each do |line|
			fp.puts(line)
		end
		fp.close


		File.delete("weather.txt")

		templine = ""
		line = ""
		linesed = ""

		fp = ""
		GC.start
	end

	def getweather2(weatherurl)
		@categ = "weather"

		pathset

		templine = []
		line = ""
		linesed = ""
		weatherMode = false
		weather2Mode = false
		@e1.setText(QString::fromUtf8("天気雨雲情報取得開始"))
		begin
		fp1 = File.open("weather.txt","w")
			open(weatherurl) do |f|
				f.each_line() do |line|
					fp1.puts(line)
				end
			end
			@okflag = true
		fp1.close
		rescue
			@okflag = false
			return
		end

		fp1 = File.open("weather.txt","r")
		fp1.each do |line|
				if (line =~ /\/LEFT_COLUMN/) != nil then
					weatherMode = true
				end
				if weatherMode then
					if (line =~ /490/) != nil then
						weather2Mode = true
					end
				end
				if weather2Mode then
					if (line =~ /clear.gif/) != nil then
							temp = line .split('"')
							if (temp[3] =~ /gif/) != nil then
								if temp[3] == nil then
								else
									@e1.setText(QString::fromUtf8("雨雲画像取得開始"))
									begin
										system("wget -P " + @yhpath + " -nv -nc -T 4 -t 1 " + temp[3] + "")
									rescue
									end
									@e1.setText(QString::fromUtf8("雨雲画像取得完了")) 
								end
							end
							sedline  = line.sub(/http:\/\/ca.c.yimg.*images\//,@yhpath)
							templine.push sedline.sub(/\.gif /,"\.gif")
					else
						if (line =~ /raincloud/) != nil then
							temp = line .split('"')
							if (temp[1] =~ /jpg/) != nil then
								if temp[1] == nil then
								else
									@e1.setText(QString::fromUtf8("雨雲画像取得開始"))
									begin
										tempweather = temp[1].sub(/http:\/\/ca.c.yimg.*raincloud\/img\//,"")
										if (FileTest.exist?(@yhpath + tempweather))
											File.delete(@yhpath + tempweather)	
										end
										system("wget -P " + @yhpath + " -nv -T 4 -t 1 " + temp[1] + "")
									rescue
									end
									@e1.setText(QString::fromUtf8("雨雲画像取得完了")) 
								end
							end
							sedline  = line.sub(/http:\/\/ca.c.yimg.*raincloud\/img\//,@yhpath)
							templine.push sedline.sub(/\.jpg /,"\.jpg")
						else
							templine.push line
						end
					end
				end
				if (line =~ /\/CONTENTS_table/) != nil then
					weatherMode = false
					weather2Mode = false
				end
		end
		fp1.close

		fp = File.open( @yhpath + "yahoo_news.txt","a")
		templine.each do |line|
			fp.puts(line)
		end
		fp.close

		templine = ""
		line = ""
		linesed = ""

		fp = ""
		GC.start
	end

	def load(filePath)
		if (!FileTest.exist?(filePath))
			return
		end
		fp = File.open(filePath, "r")
		doc = REXML::Document.new(fp)

		element = doc.elements["config/yhno"]
		if (!element.nil?)
			@l1.setText(element.attributes["yhnum"])
		end

		element = doc.elements["config/memory"]
		if (!element.nil?)
			@m1.setCurrentItem(element.attributes["save"].to_i)
		end

		element = doc.elements["config/kobetu1_url"]
		if (!element.nil?)
			@e2.setText(element.attributes["path"])
		end

		element = doc.elements["config/ch1"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c1.setChecked(true)
			end
		end

		element = doc.elements["config/ch2"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c2.setChecked(true)
			end
		end

		element = doc.elements["config/ch3"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c3.setChecked(true)
			end
		end

		element = doc.elements["config/ch4"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c4.setChecked(true)
			end
		end

		element = doc.elements["config/ch5"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c5.setChecked(true)
			end
		end

		element = doc.elements["config/ch6"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c6.setChecked(true)
			end
		end

		element = doc.elements["config/ch7"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c7.setChecked(true)
			end
		end

		element = doc.elements["config/ch8"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c8.setChecked(true)
			end
		end

		element = doc.elements["config/ch9"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c9.setChecked(true)
			end
		end

		element = doc.elements["config/ch10"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c10.setChecked(true)
			end
		end

		element = doc.elements["config/ch11"]
		if (!element.nil?)
			if(element.attributes["yhget"] =~ /true/) then
				@c11.setChecked(true)
			end
		end

		element = doc.elements["config/paths"]
		if (!element.nil?)
			$yhpaths = element.attributes["ps"]
		else
			$yhpaths = "/home/samba/SD_Card/Documents/Image_Files/"
		end

		element = doc.elements["config/pathm"]
		if (!element.nil?)
			$yhpathm = element.attributes["pm"]
		else
			$yhpathm = "/home/zaurus/Documents/Image_Files/"
		end

		element = doc.elements["config/pathc"]
		if (!element.nil?)
			$yhpathc = element.attributes["pc"]
		else
			$yhpathc = "/home/samba/CF_Card/Documents/Image_Files/"
		end


		fp.close()
	end

	def save(filePath)

		@ch1 = @c1.isChecked.to_s
		@ch2 = @c2.isChecked.to_s
		@ch3 = @c3.isChecked.to_s
		@ch4 = @c4.isChecked.to_s
		@ch5 = @c5.isChecked.to_s
		@ch6 = @c6.isChecked.to_s
		@ch7 = @c7.isChecked.to_s
		@ch8 = @c8.isChecked.to_s
		@ch9 = @c9.isChecked.to_s
		@ch10 = @c10.isChecked.to_s
		@ch11 = @c11.isChecked.to_s
		@me1 = @m1.currentItem.to_s
		@kobetu1_url = @e2.text.to_str

		fp = File.new(filePath, "w")
		fp.puts("<?xml version='1.0' encoding='UTF-8' ?>")
		fp.puts("<config>")

		str = "\t<yhno yhnum=\""
		if (!@newsmaxc.nil?)
			str += @newsmaxc
		end
		str += "\" />"
		fp.puts(str)

		str = "\t<memory save=\""
		if (!@me1.nil?)
			str += @me1
		end
		str += "\" />"
		fp.puts(str)

		str = "\t<kobetu1_url path=\""
		if (!@kobetu1_url.nil?)
			str += @kobetu1_url
		end
		str += "\" />"
		fp.puts(str)

		str = "\t<ch1 yhget=\""
		if (!@ch1.nil?)
			str += @ch1
		end
		str += "\" />"
		fp.puts(str)

		str = "\t<ch2 yhget=\""
		if (!@ch2.nil?)
			str += @ch2
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch3 yhget=\""
		if (!@ch3.nil?)
			str += @ch3
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch4 yhget=\""
		if (!@ch4.nil?)
			str += @ch4
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch5 yhget=\""
		if (!@ch5.nil?)
			str += @ch5
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch6 yhget=\""
		if (!@ch6.nil?)
			str += @ch6
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch7 yhget=\""
		if (!@ch7.nil?)
			str += @ch7
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch8 yhget=\""
		if (!@ch8.nil?)
			str += @ch8
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch9 yhget=\""
		if (!@ch9.nil?)
			str += @ch9
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch10 yhget=\""
		if (!@ch10.nil?)
			str += @ch10
		end
		str += "\" />"
		fp.puts(str)


		str = "\t<ch11 yhget=\""
		if (!@ch11.nil?)
			str += @ch11
		end
		str += "\" />"
		fp.puts(str)

		str = "\t<paths ps=\""
		if (!$yhpaths.nil?)
			str += $yhpaths
		end
		str += "\" />"
		fp.puts(str)

		str = "\t<pathm pm=\""
		if (!$yhpathm.nil?)
			str += $yhpathm
		end
		str += "\" />"
		fp.puts(str)

		str = "\t<pathc pc=\""
		if (!$yhpathc.nil?)
			str += $yhpathc
		end
		str += "\" />"
		fp.puts(str)


		fp.puts("</config>")
		fp.close()
	end
end

class SaveDirectoryDialog < QDialog
	def initialize(parent)
		super(parent)

		setCaption(tr("YahoonewsTTR"))
		bg = QVButtonGroup.new(self)

		bg.setTitle(tr("保存先ディレクトリ設定"))
		bg.setGeometry(0,30,500,300)

		@sl0 = QLabel.new(tr("SD"),self)
		@sl1 = QLabel.new(tr("本体"),self)
		@sl2 = QLabel.new(tr("CF"),self)
		@sl0.setGeometry(10,100,50,30)
		@sl1.setGeometry(10,150,50,30)
		@sl2.setGeometry(10,200,50,30)

		@se0 = QLineEdit.new("",self)
		@se0.setGeometry(70,100,390,30)
		@se1 = QLineEdit.new("",self)
		@se1.setGeometry(70,150,390,30)
		@se2 = QLineEdit.new("",self)
		@se2.setGeometry(70,200,390,30)

		@se0.setText(tr($yhpaths))
		@se1.setText(tr($yhpathm))
		@se2.setText(tr($yhpathc))

		okButton = QPushButton.new(tr("設定"), self)
		okButton.setGeometry(150, 250, 100, 30)

		connect(okButton,QSIGNAL("clicked()"), self, 'gsetpath')
	end

	def gsetpath
		$yhpaths = @se0.text.to_str
		$yhpathm = @se1.text.to_str
		$yhpathc = @se2.text.to_str
		close()
	end
end

if $0 == __FILE__ then
$defaultCodec = QTextCodec.codecForName("utf8")
QApplication.setFont(QFont.new("unifont"))
a = QPEApplication.new([$0]+ARGV)
a.setDefaultCodec($defaultCodec)
a.showMainWidget(MyWidget.new)
a.exec()
end